<template>
  <div>
    <el-dialog
      :visible.sync="StshowFormDias"
      width="70%"
      max-height="500px"
      top="7vh"
      :before-close="handleClose" :close-on-click-modal="false"
    >
      <div class="bbsl-common-page" style="display: flex">
        <div class="content-right">
          <div
            class="bbsl-table-content"
            style="height:100%;padding:0;margin:0"
          >
            <el-row :gutter="24">
              <el-col :span="10" class="left">
                <el-table
                  @selection-change="handleSelectionChange"
                  max-height="530px"
                  :data="
                    EquipmentList.filter(
                      data => !search || data.name.includes(search)
                    )
                  "
                >
                  <el-table-column type="selection" width="55">
                  </el-table-column>
                  <el-table-column label="待选择设备" prop="name">
                  </el-table-column>
                  <el-table-column align="right">
                    <template slot="header" slot-scope="">
                      <el-input
                        v-model="search"
                        size="mini"
                        clearable
                        placeholder="输入关键字搜索"
                      />
                    </template>
                  </el-table-column>
                </el-table>
              </el-col>
              <el-col :span="4" class="buttons">
                <el-button
                  style="width: 70px;margin-top: 300px;"
                  type="primary"
                  @click="leftChang"
                >
                  <i class="el-icon-arrow-left"></i>
                </el-button>
                <el-button
                  style="width: 70px;"
                  type="primary"
                  @click="rightChang"
                >
                  <i class="el-icon-arrow-right"></i>
                </el-button>
              </el-col>
              <el-col :span="10" class="right">
                <el-table
                  ref="multipleTable"
                  @selection-change="handleSelectionChange1"
                  max-height="530px"
                  :data="
                    reEquipmentList.filter(
                      data => !search1 || data.name.includes(search1)
                    )
                  "
                >
                  <el-table-column type="selection" width="55">
                  </el-table-column>
                  <el-table-column label="已选择设备" prop="name">
                  </el-table-column>
                  <el-table-column align="right">
                    <template slot="header" slot-scope="">
                      <el-input
                        v-model="search1"
                        size="mini"
                        clearable
                        placeholder="输入关键字搜索"
                      />
                    </template>
                  </el-table-column>
                </el-table>
              </el-col>
            </el-row>
          </div>
        </div>
      </div>
      <span slot="footer" class="dialog-footer">
        <el-button type="primary" @click="handleSaveRelation">关 联</el-button>
        <el-button @click="handleClose">取 消</el-button>
      </span>
    </el-dialog>
  </div>
</template>
<script>
import GroupingManage from '@/api/device/GroupingManage.js'

export default {
  name: 'AssociatedEquipmentDialog',
  props: {
    StshowFormDias: {
      type: Boolean,
      default: false
    },
    pId: {
      type: String,
      default: ''
    }
  },
  components: {},
  data() {
    return {
      search: '',
      search1: '',
      loading: false,
      multipleSelection: [], // 复选框
      multipleSelection1: [],
      leftDisabled: true,
      rightDisabled: true,
      EquipmentList: [],
      reEquipmentList: [],
      EquipmentParams: {
        address: '',
        addvcd: '',
        areaId: '',
        code: '',
        contractList: [
          {
            contractId: '',
            deviceId: '',
            id: ''
          }
        ],
        fullName: '',
        id: '',
        ip: '',
        lastTime: '',
        lgtd: '',
        lttd: '',
        memo: '',
        name: '',
        outCode: '',
        productId: '',
        status: '',
        supplierCompanyId: ''
      },
      EquipmentParams2: {
        deviceIds: [],
        deviceList: [
          {
            address: '',
            addvcd: '',
            areaId: '',
            code: '',
            contractList: [
              {
                contractId: '',
                deviceId: '',
                id: ''
              }
            ],
            fullName: '',
            id: '',
            ip: '',
            lastTime: '',
            lgtd: '',
            lttd: '',
            memo: '',
            name: '',
            outCode: '',
            productId: '',
            status: '',
            supplierCompanyId: ''
          }
        ],
        groupId: ''
      },
      relationList: {
        deviceIds: [],
        groupId: ''
      }
    }
  },
  created() {
    this.relationList.groupId = this.pId
    this.EquipmentParams2.groupId = this.pId
    this.getEquipmentData()
  },
  methods: {
    // 获取已关联设备数据
    // reEquipmentData() {
    //   GroupingManage.relatedEquipment(this.EquipmentParams2, res => {
    //     this.reEquipmentList = res.value.deviceList
    //     if (this.reEquipmentList.length > 0) {
    //       this.$nextTick(() => {
    //         this.$refs.multipleTable.toggleAllSelection()
    //       })
    //     }
    //   })
    // },

    // 获取设备列表
    getEquipmentData() {
      GroupingManage.relatedEquipment(this.EquipmentParams2, res => {
        this.reEquipmentList = res.value.deviceList
        GroupingManage.findEquipmentList(this.EquipmentParams, res => {
          this.EquipmentList = res.value
          if (res.state) {
            if (this.reEquipmentList.length > 0) {
              this.$nextTick(() => {
                this.$refs.multipleTable.toggleAllSelection()
              })
            }
            this.EquipmentList = this.EquipmentList.filter(
              item => !this.reEquipmentList.some(value => value.id == item.id)
            )
          }
        })
      })
    },

    // 未关联设备
    handleSelectionChange(val) {
      this.multipleSelection = val
    },
    // 已关联设备
    handleSelectionChange1(val) {
      this.multipleSelection1 = val
    },
    // 赋值
    rightChang() {
      this.reEquipmentList = this.reEquipmentList.concat(this.multipleSelection)
      this.EquipmentList = this.EquipmentList.filter(
        item => !this.reEquipmentList.some(citem => citem.id == item.id)
      )
    },
    leftChang() {
      this.EquipmentList = this.EquipmentList.concat(this.multipleSelection1)
      this.reEquipmentList = this.reEquipmentList.filter(
        item2 => !this.EquipmentList.some(citem2 => citem2.id == item2.id)
      )
    },
    handleSaveRelation() {
      this.reEquipmentList.forEach(item => {
        this.relationList.deviceIds.push(item.id)
      })
      if (!!this.relationList) {
        GroupingManage.ConnectionEquipment(this.relationList, res => {
          if (res.state) {
            this.$notify({
              type: 'success',
              message: '设备关联成功',
              duration: 2000
            })
            this.$emit('loadData')
            this.handleClose()
          } else {
            this.$message.warning(response.message)
          }
        })
      }
    },
    handleClose() {
      this.EquipmentParams2.groupId = ''
      this.reEquipmentList = []
      this.EquipmentList = []
      this.$emit('closeStshowForm')
    }
  }
}
</script>
<style lang="scss" scoped>
.el-tree-node__content {
  width: 100% !important;
  height: 40px !important;
  flex: 1;
  display: flex !important;
  // align-items: center !important;
  justify-content: space-around !important;
  font-size: 14px;
  // padding-right: 8px;
}

.left {
  height: 650px !important;
  // overflow: auto !important;
}

.right {
  height: 650px !important;
  // overflow: auto !important;
}

.el-transfer-panel {
  height: 100% !important;
  width: 100% !important;
}

.btn-content {
  display: flex;
}

.el-dialog__body {
  // height: 650px !important;
  // overflow: auto !important;
}

::v-deep .bbsl-table-content {
  box-shadow: 0px 0px 0 0;
}

.el-select-dropdown__item span {
  color: rgb(51, 51, 51) !important;
}

.el-select-dropdown__item {
  color: #9a9a9a !important;
}

.el-select-dropdown__item.hover,
.el-select-dropdown__item:hover {
  background: #f5f7fa;
}

.btn-content :first-child {
  margin: 0 0 0 0 !important;
}

.el-card__body {
  width: 100% !important;
  height: 100% !important;
}

.custom-tree-node {
  box-sizing: border-box;
  display: flex;
  justify-content: space-around !important;
}

.custom-tree-node {
  flex: 1;
  display: flex;
  align-items: center;
  justify-content: space-between;
  font-size: 14px;
  padding-right: 5px;
}

.el-card {
  width: 100% !important;
  height: 100% !important;
}

.el-main {
  width: 100% !important;
  height: 100% !important;
}

.fullheight {
  display: flex !important;
  width: 100% !important;
  height: 100%;
}

.content-left {
  width: 20% !important;
  border-right: 1px solid #ccc;
}

.content-right {
  width: 100% !important;
}

.sampling {
  ::v-deep .el-dialog__body {
    padding: 30px 20px 0 20px;
  }
}

::-webkit-scrollbar {
  background: #fff !important;
}

.custom-tree-node {
  font-size: 12px;
}

.el-popover {
  min-width: 35px !important;
  padding: 5px 0 !important;
}

.line {
  display: block !important;
  height: 1px !important;
  background: #ccc !important;
}

.checkbox-group {
  height: 454px !important;
}
</style>
